--[[
FlaskMinder Buff reminder utility inspired by Nytshade of TeAm TyPo

Initial code was based on AntiSlack by Battleguard of Balnazzar.

Author: DigitalSorceress
Date: 2014/10/12
Version: 6.0.2.000
]]

-- Some initialization of our happy local vars
local myVersion = "v6.0.2.000"

local soundList = {
  [1] =  { name = "none",        path = "" },
  [2] =  { name = "Raid Warn",   path = "Sound\\interface\\RaidWarning.wav" },
  [3] =  { name = "Moo",         path = "Sound\\Spells\\PolyMorphCow.wav" },
  [4] =  { name = "Moo2",        path = "Sound\\Creature\\Cow\\CowDeath.wav" },
  [5] =  { name = "Ta-Da",       path = "Sound\\Spells\\PVPFlagTaken.wav" },
  [6] =  { name = "Tadpole",     path = "Sound\\Creature\\BabyMurloc\\BabyMurlocA.wav" },
  [7] =  { name = "Yahh",        path = "Sound\\Character\\Human\\MaleNPC\\HumanMalePirateHeavy\\HumanMalePirateHeavyAggro.wav" },
  [8] =  { name = "Murmur",      path = "Sound\\Creature\\Murmur\\MurmurSpawn.wav" },
  [9] =  { name = "Turkey",      path = "Sound\\Creature\\turkey\\TurkeyAttackA.wav" },
  [10] = { name = "Klunk",       path = "Sound\\Doodad\\ArcaneCrystalOpen.wav" },
  [11] = { name = "Gong",        path = "Sound\\Doodad\\G_GongTroll01.wav" },
  [12] = { name = "Gong2",       path = "Sound\\Doodad\\BellTollHorde.wav" },
  [13] = { name = "Drum",        path = "Sound\\Doodad\\BellTollTribal.wav" },
  [14] = { name = "Ding Ding",   path = "Sound\\Doodad\\BoatDockedWarning.wav" },
  [15] = { name = "Boom",        path = "Sound\\Doodad\\Cannon01_BlastA.wav" },
  [16] = { name = "Klank",       path = "Sound\\Doodad\\DireMaulCrystalGeneratorOpen.wav" },
  [17] = { name = "Thunk",       path = "Sound\\Item\\Weapons\\Shields\\MetalShieldBlock2.wav" },
  [18] = { name = "USE DEFAULT", path = "" },
}
-- FlaskMinder = LibStub("AceAddon-3.0"):NewAddon("FlaskMinder", "AceConsole-3.0","AceComm-3.0","AceEvent-3.0","AceSerializer-3.0")
FlaskMinder = LibStub("AceAddon-3.0"):NewAddon("FlaskMinder", "AceConsole-3.0","AceEvent-3.0","AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("FlaskMinder")

-- MUST set these after the Localizations are pulled in
local masterList = {}
masterList.GEx = {
  L["G_ELIXIR_OF_MIRRORS"],
  L["G_MANTID_ELIXIR"],
  L["G_ELIXIR_OF_DEEP_EARTH"],
  L["G_PRISMATIC_ELIXIR"],
  L["G_ARMOR"],
  L["G_CRYSTAL_FORCE"],
  L["G_CRYSTAL_WARD"],
  L["G_EARTHEN_ELIXIR"],
  L["G_ELIXIR_OF_DRAENIC_WISDOM"],
  L["G_ELIXIR_OF_FORTITUDE"],
  L["G_ELIXIR_OF_IRONSKIN"],
  L["G_ELIXIR_OF_MAJOR_FORTITUDE"],
  L["G_ELIXIR_OF_MIGHTY_FORTITUDE"],
  L["G_ELIXIR_OF_SPIRIT"],
  L["G_ELIXIR_OF_THE_SAGES"],
  L["G_EMPOWERMENT"],
  L["G_GIFT_OF_ARTHAS"],
  L["G_GREATER_ARMOR"],
  L["G_GREATER_INTELLECT"],
  L["G_GREATER_MANA_REGENERATION"],
  L["G_HEALTH"],
  L["G_INFALLIBLE_MIND"],
  L["G_JUJU_CHILL"],
  L["G_JUJU_EMBER"],
  L["G_JUJU_ESCAPE"],
  L["G_JUJU_GUILE"],
  L["G_LESSER_ARMOR"],
  L["G_LESSER_INTELLECT"],
  L["G_MAGEBLOOD_ELIXIR"],
  L["G_MAJOR_ARMOR"],
  L["G_MAJOR_TROLLS_BLOOD_ELIXIR"],
  L["G_MIGHTY_DEFENSE"],
  L["G_MIGHTY_MANA_REGENERATION"],
  L["G_MIGHTY_THOUGHTS"],
  L["G_MIGHTY_TROLLS_BLOOD_ELIXIR"],
  L["G_PROTECTION"],
  L["G_SHEEN_OF_ZANZA"],
  L["G_SPIRIT_OF_BOAR"],
  L["G_SPIRIT_OF_ZANZA"],
  L["G_SPIRITUAL_DOMINATION"],
  L["G_STRONG_TROLLS_BLOOD_ELIXIR"],
  L["G_SWIFTNESS_OF_ZANZA"],
  L["G_WATER_WALKING"],
  L["G_WEAK_TROLLS_BLOOD_ELIXIR"],
};
masterList.BEx = {
  L["B_MAD_HOZEN_ELIXIR"],
  L["B_ELIXIR_OF_THE_RAPIDS"],
  L["B_ELIXIR_OF_PERFECTION"],
  L["B_ELIXIR_OF_PEACE"],
  L["B_ELIXIR_OF_WEAPONRY"],
  L["B_MONKS_ELIXIR"],
  L["B_ELIXIR_OF_IMPOSSIBLE_ACCURACY"],
  L["B_ELIXIR_OF_MIGHTY_SPEED"],
  L["B_ELIXIR_OF_THE_COBRA"],
  L["B_ELIXIR_OF_THE_MASTER"],
  L["B_ELIXIR_OF_THE_NAGA"],
  L["B_GHOST_ELIXIR"],
  L["B_ACCURACY"],
  L["B_ADEPTS_ELIXIR"],
  L["B_AGILITY"],
  L["B_ARCANE_ELIXIR"],
  L["B_ARMOR_PIERCING"],
  L["B_BLOODBERRY"],
  L["B_DEADLY_STRIKES"],
  L["B_ELIXIR_OF_BRUTE_FORCE"],
  L["B_ELIXIR_OF_DEMONSLAYING"],
  L["B_ELIXIR_OF_MASTERY"],
  L["B_ELIXIR_OF_MINOR_ACCURACY"],
  L["B_ELIXIR_OF_THE_GIANTS"],
  L["B_ELIXIR_OF_THE_MONGOOSE"],
  L["B_ENLARGE"],
  L["B_EXPERTISE"],
  L["B_FEL_STRENGTH_ELIXIR"],
  L["B_FIRE_POWER"],
  L["B_FROST_POWER"],
  L["B_GREATER_AGILITY"],
  L["B_GREATER_ARCANE_ELIXIR"],
  L["B_GREATER_FIREPOWER"],
  L["B_GURUS_ELIXIR"],
  L["B_HEALING_POWER"],
  L["B_JUJU_FLURRY"],
  L["B_JUJU_MIGHT"],
  L["B_JUJU_POWER"],
  L["B_LESSER_AGILITY"],
  L["B_LESSER_STRENGTH"],
  L["B_LIGHTNING_SPEED"],
  L["B_MAJOR_AGILITY"],
  L["B_MAJOR_FIREPOWER"],
  L["B_MAJOR_FROST_POWER"],
  L["B_MAJOR_SHADOW_POWER"],
  L["B_MAJOR_STRENGTH"],
  L["B_MIGHTY_AGILITY"],
  L["B_MIGHTY_STRENGTH"],
  L["B_ONSLAUGHT_ELIXIR"],
  L["B_RAGE_OF_AGES"],
  L["B_SHADOW_POWER"],
  L["B_SPELLPOWER_ELIXIR"],
  L["B_STRENGTH"],
  L["B_STRIKE_OF_THE_SCORPOK"],
  L["B_WINTERFALL_FIREWATER"],
  L["B_WRATH_ELIXIR"],
};
masterList.FEx = {
  L["F_DRAENIC_AGILITY_FLASK"],
  L["F_DRAENIC_INTELLECT_FLASK"],
  L["F_DRAENIC_STAMINA_FLASK"],
  L["F_DRAENIC_STRENGTH_FLASK"],
  L["F_GREATER_DRAENIC_AGILITY_FLASK"],
  L["F_GREATER_DRAENIC_INTELLECT_FLASK"],
  L["F_GREATER_DRAENIC_STAMINA_FLASK"],
  L["F_GREATER_DRAENIC_STRENGTH_FLASK"],
  L["F_FLASK_OF_FALLING_LEAVES"],
  L["F_FLASK_OF_SPRING_BLOSSOMS"],
  L["F_FLASK_OF_THE_WARM_SUN"],
  L["F_FLASK_OF_THE_EARTH"],
  L["F_FLASK_OF_WINTERS_BITE"],
  L["F_ENHANCED_INTELLECT"],
  L["F_ENHANCED_STRENGTH"],
  L["F_ENHANCED_AGILITY"],
  L["F_FLASK_OF_FLOWING_WATER"],
  L["F_FLASK_OF_STEELSKIN"],
  L["F_FLASK_OF_THE_DRACONIC_MIND"],
  L["F_FLASK_OF_THE_WINDS"],
  L["F_FLASK_OF_TITANIC_STRENGTH"],
  L["F_BLINDING_LIGHT_OF_SHATTRATH"],
  L["F_CHROMATIC_RESISTANCE"],
  L["F_CHROMATIC_WONDER"],
  L["F_DISTILLED_WISDOM"],
  L["F_FLASK_OF_BLINDING_LIGHT"],
  L["F_FLASK_OF_ENDLESS_RAGE"],
  L["F_FLASK_OF_FORTIFICATION"],
  L["F_FLASK_OF_MIGHTY_RESTORATION"],
  L["F_FLASK_OF_PURE_DEATH"],
  L["F_FLASK_OF_PURE_MOJO"],
  L["F_FLASK_OF_RELENTLESS_ASSAULT"],
  L["F_FLASK_OF_STONEBLOOD"],
  L["F_FLASK_OF_THE_FROST_WYRM"],
  L["F_FLASK_OF_THE_NORTH"],
  L["F_FLASK_OF_THE_TITANS"],
  L["F_FORTIFICATION_OF_SHATTRATH"],
  L["F_LESSER_FLASK_OF_TOUGHNESS"],
  L["F_MIGHTY_RESTORATION_OF_SHATTRATH"],
  L["F_PETRIFICATION"],
  L["F_PURE_DEATH_OF_SHATTRATH"],
  L["F_RELENTLESS_ASSAULT_OF_SHATTRATH"],
  L["F_SUPREME_POWER"],
  L["F_SUPREME_POWER_OF_SHATTRATH"],
  L["F_UNSTABLE_FLASK_OF_THE_BANDIT"],
  L["F_UNSTABLE_FLASK_OF_THE_BEAST"],
  L["F_UNSTABLE_FLASK_OF_THE_ELDER"],
  L["F_UNSTABLE_FLASK_OF_THE_PHYSICIAN"],
  L["F_UNSTABLE_FLASK_OF_THE_SOLDIER"],
  L["F_UNSTABLE_FLASK_OF_THE_SORCERER"],
};

masterList.XEx = { -- Exclusion list: used for filtering buffs that have the same name as elixirs but are different effects
  "Interface\\Icons\\Ability_Warrior_DefensiveStance", -- Armor buff from scrolls (conflicts with Defense potions)
  "Interface\\Icons\\Spell_Frost_WindWalkOn", -- Shaman's Water Walking spell
  "Interface\\Icons\\Spell_Holy_BlessingOfAgility", -- Agility buff from scrolls (conflicts with Agility potions)
  "Interface\\Icons\\Spell_Nature_Strength", -- Strength buff from scrolls (conflicts with Strength potions)
  "Interface\\Icons\\Spell_Holy_MindVision", -- Trinket proc from Heavenly Inspiration (http://www.wowhead.com/?item=30293), conflicts with Healing Power potion
  "Interface\\Icons\\Ability_Warrior_ShieldMastery", -- ?? I don't remember why I put them here, but I must have had a good reason for that,
  "Interface\\Icons\\Spell_Nature_UnyeildingStamina", -- ?? I'll leave these here for now...
  "Interface\\Icons\\Spell_Nature_UnrelentingStorm" -- Proc from Mongoose enchant (http://www.wowhead.com/?spell=28093), conflicts with Haste potion
};

-- ------------------------------------------------
-- CONFIGURATION STUFF
-- ------------------------------------------------
-- Holds our configuration options
local options = {
  name = "FlaskMinder",
  handler = FlaskMinder,
  type = "group",
  childGroups = "select",
  get = "getConfigOption",
  set = "setConfigOption",
  args = {
    mainDescription = {
      type = "description",
      name = L["MAIN_DESCRIPTION"],
      order = 1
    },
    strictOptionsGroupContainer = {
      type = "group",
      name = L["STRICT_GROUP_NAME"],
      inline = true,
      order = 2,
      args = {
        strictGroupDesc = {
          type = "description",
          name = L["STRICT_GROUP_DESC"],
          order = 1
        },
        strictFoodFlag = {
          type = "toggle",
          name = L["STRICT_FOOD_NAME"],
          desc = L["STRICT_FOOD_DESC"],
          order = 2
        },
        strictElixirFlag = {
          type = "toggle",
          name = L["STRICT_ELIXIR_NAME"],
          desc = L["STRICT_ELIXIR_DESC"],
          order = 3
        }
      }
    },
    updateOptionsGroupContainer = {
      type = "group",
      name = L["UPDATE_GROUP_NAME"],
      inline = true,
      order = 3,
      args = {
        updateGroupDesc = {
          type = "description",
          name = L["UPDATE_GROUP_DESC"],
          order = 1
        },
        updateEnterCombatFlag = {
          type = "toggle",
          name = L["UPDATE_ENTER_COMBAT_NAME"],
          desc = L["UPDATE_ENTER_COMBAT_DESC"],
          order = 2
        },
        updateExitCombatFlag = {
          type = "toggle",
          name = L["UPDATE_EXIT_COMBAT_NAME"],
          desc = L["UPDATE_EXIT_COMBAT_DESC"],
          order = 3
        },
        updateUseTimerFlag = {
          type = "toggle",
          name = L["UPDATE_USE_TIMER_NAME"],
          desc = L["UPDATE_USE_TIMER_DESC"],
          order = 4
        },
        updateReadyCheckFlag = {
          type = "toggle",
          name = L["UPDATE_READY_CHECK_NAME"],
          desc = L["UPDATE_READY_CHECK_DESC"],
          order = 5
        },
      }
    },
  }
}


local timingOptions = {
  name = L["TIMING_OPTIONS_NAME"],
  handler = FlaskMinder,
  type = "group",
  order = 2,
  get = "getConfigOption",
  set = "setConfigOption",
  args = {
    timingOptionsDesc = {
      type = "description",
      name = L["TIMING_OPTIONS_DESC"],
      order = 1
    },
    timingExpireWarnGroupContainer = {
      type = "group",
      name = L["TIMING_EXPIRE_WARN_GROUP_NAME"],
      inline = true,
      order = 1,
      args = {
        timingExpireWarnGroupDesc = {
          type = "description",
          name = L["TIMING_EXPIRE_WARN_GROUP_DESC"],
          order = 1
        },
        timingExpireWarnFlag = {
          type = "toggle",
          name = L["TIMING_EXPIRE_WARN_FLAG_NAME"],
          desc = L["TIMING_EXPIRE_WARN_FLAG_DESC"],
          order = 2
        },
        timingExpireWarnTime = {
          type = "select",
          name = L["TIMING_EXPIRE_WARN_TIME_NAME"],
          desc = L["TIMING_EXPIRE_WARN_TIME_DESC"],
          order = 3,
          values = {
          --[seconds] = "human readable value",
            [60]  = "1 minute",
            [300] = "5 minutes",
            [600] = "10 minutes",
            [900] = "15 minutes"
          },
        },
      }
    },
    timingMasterTimerGroupContainer = {
      type = "group",
      name = L["TIMING_MASTER_TIMER_GROUP_NAME"],
      inline = true,
      order = 1,
      args = {
        timingMasterTimerGroupDesc = {
          type = "description",
          name = L["TIMING_MASTER_TIMER_GROUP_DESC"],
          order = 1
        },
        timingMasterTimerFreq = {
          type = "select",
          name = L["TIMING_MASTER_TIMER_FREQ_NAME"],
          desc = L["TIMING_MASTER_TIMER_FREQ_DESC"],
          order = 2,
          set = "UpdateMasterTimer",
          values = {
          --[seconds] = "human readable value",
            [60]  = "1 minute (recommended)",
            [300] = "5 minutes",
            [600] = "10 minutes",
            [900] = "15 minutes"
          },
        },
      }
    },
  }
}




local filterOptions = {
  name = L["FILTER_OPTIONS_NAME"],
  handler = FlaskMinder,
  type = "group",
  order = 3,
  get = "getConfigOption",
  set = "setConfigOption",
  args = {
    filterOptionsDesc = {
      type = "description",
      name = L["FILTER_OPTIONS_DESC"],
      order = 1
    },
    instanceFilterGroupContainer = {
      type = "group",
      name = L["INSTANCE_FILTER_GROUP_NAME"],
      inline = true,
      order = 2,
      args = {
        instanceFilterGroupDesc = {
          type = "description",
          name = L["INSTANCE_FILTER_GROUP_DESC"],
          order = 1
        },
        instanceFilterPartyFlag = {
          type = "toggle",
          name = L["INSTANCE_FILTER_PARTY_NAME"],
          desc = L["INSTANCE_FILTER_PARTY_DESC"],
          order = 2,
        },
        instanceFilterRaidFlag = {
          type = "toggle",
          name = L["INSTANCE_FILTER_RAID_NAME"],
          desc = L["INSTANCE_FILTER_RAID_DESC"],
          order = 3,
        },
        instanceFilterBgFlag = {
          type = "toggle",
          name = L["INSTANCE_FILTER_BG_NAME"],
          desc = L["INSTANCE_FILTER_BG_DESC"],
          order = 4,
        },
      }
    },
    groupFilterGroupContainer = {
      type = "group",
      name = L["GROUP_FILTER_GROUP_NAME"],
      inline = true,
      order = 3,
      args = {
        groupFilterGroupDesc = {
          type = "description",
          name = L["GROUP_FILTER_GROUP_DESC"],
          order = 1
        },
        groupFilterSoloFlag = {
          type = "toggle",
          name = L["GROUP_FILTER_SOLO_NAME"],
          desc = L["GROUP_FILTER_SOLO_DESC"],
          order = 2,
        },
        groupFilterPartyFlag = {
          type = "toggle",
          name = L["GROUP_FILTER_PARTY_NAME"],
          desc = L["GROUP_FILTER_PARTY_DESC"],
          order = 3,
        },
        groupFilterRaidFlag = {
          type = "toggle",
          name = L["GROUP_FILTER_RAID_NAME"],
          desc = L["GROUP_FILTER_RAID_DESC"],
          order = 4,
        },
      }
    },
    vehicleFilterGroupContainer = {
      type = "group",
      name = L["VEHICLE_FILTER_GROUP_NAME"],
      inline = true,
      order = 4,
      args = {
        vehicleFilterGroupDesc = {
          type = "description",
          name = L["VEHICLE_FILTER_GROUP_DESC"],
          order = 1,
        },
        vehicleFilterFlag = {
          type = "toggle",
          name = L["VEHICLE_FILTER_NAME"],
          desc = L["VEHICLE_FILTER_DESC"],
          order = 2,
        },
      }
    },
  }
}


local soundOptions = {
  name = L["SOUND_OPTIONS_NAME"],
  handler = FlaskMinder,
  type = "group",
  order = 4,
  get = "getConfigOption",
  set = "setConfigOption",
  args = {
    defaultSoundGroupContainer = {
      type = "group",
      name = L["DEFAULT_SOUND_GROUP_NAME"],
      inline = true,
      order = 2,
      args = {
        defaultSoundGroupDesc = {
          type = "description",
          name = L["DEFAULT_SOUND_GROUP_DESC"],
          order = 1
        },
        defaultWarnSound = {
          type = "select",
          name = L["PICK_SOUND_NAME"],
          desc = L["PICK_SOUND_DESC"],
          order = 2,
          values = function(info) return FlaskMinder:getSoundSelectTable(true) end,
        },
        defaultWarnSoundTest = {
          type = "execute",
          name = L["PICK_SOUND_TEST"],
          func = function(info) FlaskMinder:soundCheck("defaultWarnSound") end,
          order = 3,
        }
      }
    },
  }
}

local debugOptions = {
  name = L["DEBUG_OPTIONS_NAME"],
  handler = FlaskMinder,
  type = "group",
  order = 5,
  get = "getConfigOption",
  set = "setConfigOption",
  args = {
    debugFlag = {
      type = "toggle",
      name = L["DEBUG_NAME"],
      desc = L["DEBUG_DESC"],
      order = 1,
    },
    blatherFlag = {
      type = "toggle",
      name = L["BLATHER_NAME"],
      desc = L["BLATHER_DESC"],
      order = 2,
    }
  }
}


--
-- Set the default profile if they don't have one
--
local defaults = {
  profile = {
    strictFoodFlag = false,
    strictElixirFlag = false,
    updateEnterCombatFlag = false,
    updateExitCombatFlag = false,
    updateReadyCheckFlag = true,
    updateUseTimerFlag = true,
    groupFilterSoloFlag = false,
    groupFilterPartyFlag = false,
    groupFilterRaidFlag = false,
    instanceFilterPartyFlag = false,
    instanceFilterRaidFlag = true,
    instanceFilterBgFlag = false,
    timingExpireWarnFlag = true,
    timingExpireWarnTime = 300,
    timingMasterTimerFreq = 60,
    vehicleFilterFlag = false,
    debugFlag = false,
    blatherFlag = false,
    defaultWarnSound = 2,
  }
}


--
-- Field handlers
--
function FlaskMinder:getConfigOption(key)
  self:debugMsg("getConfigOption()", "debug")
  self:debugMsg("  key[#key]: "..tostring(key[#key]), "debug")
  return self.db.profile[key[#key]]
end


function FlaskMinder:setConfigOption(key, value)
  self:debugMsg("setConfigOption()", "debug")
  self:debugMsg("  key: "..tostring(key[#key]), "debug")
  self:debugMsg("  val: "..tostring(value), "debug")
  self.db.profile[key[#key]] = value
end


--
-- Chat Command setup
--
function FlaskMinder:ChatCommand(input)
  self:debugMsg("ChatCommand initiated", "debug");
  self:debugMsg("  input: "..tostring(input), "debug");

  if not input or input:trim() == "" then
    -- This would use the Ace config gui
    -- LibStub("AceConfigDialog-3.0"):Open("FlaskMinder")
    -- This uses the Bliz options pane instead
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
  elseif input == "timer" or input == "timeLeft" then
    self:debugMsg("Checking Master Timer Time Left", "debug");
    local timeLeft = self:TimeLeft( self.masterTimer );
    self:debugMsg("  timeLeft: "..tostring(timeLeft).." seconds", "debug");

  elseif input == "group" then

    local gtcResult = self:groupTypeCheck();
    self:debugMsg("  gtcResult: "..tostring(gtcResult), "debug");

  elseif input == "debug" then
    local newValue = true;

    if self.db.profile.debugFlag then
      newValue = false;
    else
      newValue = true;
    end
    self.db.profile.debugFlag = newValue

  elseif input == "blather" then
    local newValue = true;

    if self.db.profile.blatherFlag then
      newValue = false;
    else
      newValue = true;
    end
    self.db.profile.blatherFlag = newValue

  elseif input == "check" or input == "checkNow" then

    self:checkBuffs( false );
  else
    --LibStub("AceConfigCmd-3.0").HandleCommand(FlaskMinder, L["SHORT_SLASH_CMD"], L["FULL_SLASH_CMD"], input)
    self:helpCommand(input);
  end
end

-- ------------------------------------------------
-- BASIC REQUIRED FUNCTIONS
-- ------------------------------------------------

-- Called when the addon is loaded
function FlaskMinder:OnInitialize()
  -- Using the AceDB for storage of our info
  self.db = LibStub("AceDB-3.0"):New("FlaskMinderDB", defaults, "Default");

  -- main options table stuff
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Options", options);
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Filter Options", filterOptions);
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Timing Options", timingOptions);
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Sound Options", soundOptions);
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Debug Options", debugOptions);
  LibStub("AceConfig-3.0"):RegisterOptionsTable("FlaskMinder Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db));

  -- adding to Blizzard options configuration
  self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Options", "FlaskMinder");
  self.optionsFrame.filterOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Filter Options", L["FILTER_OPTIONS_NAME"], "FlaskMinder");
  self.optionsFrame.timingOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Timing Options", L["TIMING_OPTIONS_NAME"], "FlaskMinder");
  self.optionsFrame.soundOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Sound Options", L["SOUND_OPTIONS_NAME"], "FlaskMinder");
  self.optionsFrame.debugOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Debug Options", L["DEBUG_OPTIONS_NAME"], "FlaskMinder");
  self.optionsFrame.Profiles = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FlaskMinder Profiles", "Profiles", "FlaskMinder");

  -- registering the slash commands
  self:RegisterChatCommand(L["FULL_SLASH_CMD"], "ChatCommand");
  self:RegisterChatCommand(L["SHORT_SLASH_CMD"], "ChatCommand");
  -- self:RegisterChatCommand("help", "helpCommand");

  -- one last thing, initialize self.inCombat
  self.inCombat = false;
end


-- Called when the addon is enabled
function FlaskMinder:OnEnable()
  -------------------
  -- REGISTER EVENTS
  -------------------
  self:RegisterEvent("PLAYER_REGEN_DISABLED", "enterCombat");
  self:RegisterEvent("PLAYER_REGEN_ENABLED", "exitCombat");
  self:RegisterEvent("READY_CHECK", "readyCheck");

  -----------------------------
  -- SECUE HOOKS (post-hooking)
  -----------------------------
  -- NONE


  -- TIMER SETUP
  self:UpdateMasterTimer(nil, nil);

  --------------------
  -- FINAL PRE-LAUNCH
  --------------------

  self:Print("FlaskMinder "..myVersion.." ENABLED!");
end


-- Called when the addon is disabled
function FlaskMinder:OnDisable()
  --
end


function FlaskMinder:UpdateMasterTimer(key, value)
  self:debugMsg("UpdateMasterTimer()", "debug");
  self:debugMsg("  key:"..tostring(key), "blather");
  self:debugMsg("  value:"..tostring(value), "blather");

  local newValue = 0;

  -- checking if we were passed a key or value - if we were, then we need to do the update before anything else
  if key and value then
    self:debugMsg("  key/value pair detected, setting config", "blather");
    self:setConfigOption(key, value);

    newValue = self:getConfigOption(key);
  end
  self:debugMsg("  newValue:"..tostring(newValue), "blather");

  -- hopefully this works withough bitching

  -- checking for existint timer
  self:debugMsg("  Checking for existing timer...", "blather");
  if self.masterTimer then
    -- found one, cancel it
    self:debugMsg("    masterTimer found: cancelling", "blather");
    local cancelResult = self:CancelTimer( self.masterTimer, true );
    self:debugMsg("      cancelResult: "..tostring(cancelResult), "blather");
  else
    -- none found
    self:debugMsg("    masterTimer not found", "blather");
  end
  -- if not, try this
  -- self:CancelAllTimers();

  -- doon't do anything unless we're using the master timer
  self:debugMsg("  Checking masterTimer config...", "blather");
  self:debugMsg("    updateUseTimerFlag: "..tostring(self.db.profile.updateUseTimerFlag), "blather");
  self:debugMsg("    timingMasterTimerFreq: "..tostring(self.db.profile.timingMasterTimerFreq), "blather");
  if self.db.profile.updateUseTimerFlag and self.db.profile.timingMasterTimerFreq then
    -- conditions met, set the timer
    self:debugMsg("  Conditions met... setting timer", "blather");
    self.masterTimer = self:ScheduleRepeatingTimer( "MasterTimerHandler", self.db.profile.timingMasterTimerFreq );
  else
    -- conditions not met, don't set timer
    self:debugMsg("  Conditions NOT met... no timer", "blather");
  end

end


function FlaskMinder:MasterTimerHandler(info)
  self:debugMsg("MasterTimerHandler()", "debug");
  self:debugMsg("  info: "..tostring(info), "blther");

  if self.db.profile.updateUseTimerFlag then
    self:debugMsg("  updateUseTimerFlag found, calling checkBuffs", "blather");
    -- Do buff check - ignore food warning since you can't fix it now
    self:checkBuffs( self.inCombat );
  end
end


-- ------------------------------------------------
-- EVENT HANDLERS
-- ------------------------------------------------

-- Fired when player enters combat
function FlaskMinder:enterCombat(info)
  self:debugMsg("enterCombat()", "debug");
  self:debugMsg("  info: "..tostring(info), "blather");
  self:debugMsg("  updateEnterCombatFlag: "..tostring(self.db.profile["updateEnterCombatFlag"]), "blather");

  self.inCombat = true;

  if self.db.profile["updateEnterCombatFlag"] then
    self:debugMsg("  updateEnterCombatFlag Triggered: ", "debug");
    -- Do buff check - ignore food warning since you can't fix it now
    self:checkBuffs( self.inCombat );
  end
end

-- Fired when player leaves combat
function FlaskMinder:exitCombat(info)
  self:debugMsg("exitCombat()", "debug");
  self:debugMsg("  info: "..tostring(info), "blather");
  self:debugMsg("  exitCombatFlag: "..tostring(self.db.profile["exitCombatFlag"]), "blather");

  self.inCombat = false;

  if self.db.profile["updateExitCombatFlag"] then
    self:debugMsg("  updateExitCombatFlag Triggered: ", "debug");
   -- Do buff check - Include food
    self:checkBuffs( self.inCombat );
  end
end


-- Fired when ready check goes out
function FlaskMinder:readyCheck(info)
  self:debugMsg("readyCheck()", "debug");
  self:debugMsg("  info: "..tostring(info), "blather");
  self:debugMsg("  updateReadyCheckFlag: "..tostring(self.db.profile["updateReadyCheckFlag"]), "blather");

  if self.db.profile["updateReadyCheckFlag"] then
    self:debugMsg("  updateReadyCheckFlag Triggered: ", "debug");
    -- Do buff check - If we're in combat, we say so
    self:checkBuffs( self.inCombat );
  end
end

-- ------------------------------------------------
-- MAIN APP FUNCTIONALITY
-- ------------------------------------------------
function FlaskMinder:FilterCheck()
  self:debugMsg("FilterCheck()", "blather");
  self:debugMsg("  groupFilterSoloFlag: "..tostring(self.db.profile.groupFilterSoloFlag), "blather");
  self:debugMsg("  groupFilterPartyFlag: "..tostring(self.db.profile.groupFilterPartyFlag), "blather");
  self:debugMsg("  groupFilterRaidFlag: "..tostring(self.db.profile.groupFilterRaidFlag), "blather");
  self:debugMsg("  instanceFilterPartyFlag: "..tostring(self.db.profile.instanceFilterPartyFlag), "blather");
  self:debugMsg("  instanceFilterRaidFlag: "..tostring(self.db.profile.instanceFilterRaidFlag), "blather");
  self:debugMsg("  instanceFilterBgFlag: "..tostring(self.db.profile.instanceFilterBgFlag), "blather");
  self:debugMsg("  timingExpireWarnFlag: "..tostring(self.db.profile.timingExpireWarnFlag), "blather");
  self:debugMsg("  timingExpireWarnTime: "..tostring(self.db.profile.timingExpireWarnTime), "blather");
  self:debugMsg("  vehicleFilterFlag: "..tostring(self.db.profile.vehicleFilterFlag), "blather");

  local returnValue = false;

  -- Vehicle checking is easy enough
  self:debugMsg("  Checking IsInVehicle...", "blather");
  local inVehicle = UnitInVehicle("player");
  self:debugMsg("    inVehicle: "..tostring(inVehicle), "blather");

  if inVehicle and not self.db.profile.vehicleFilterFlag then
    -- In vehicle, but not flagged for vehicle, we can just stop right here
    self:debugMsg("      inVehicle true, but vehicleFilterFlag is false... stopping check", "blather");
    return false;
  end

  -- now deal with the instance/raid mess
  self:debugMsg("  Checking IsInInstance...", "blather");
  local inInstance, instanceType = IsInInstance();
  self:debugMsg("    inInstance: "..tostring(inInstance), "blather");
  self:debugMsg("    instanceType: "..tostring(instanceType), "blather");

  if inInstance == 1 then
    -- In-instance type checking

    if instanceType == "party" and self.db.profile.instanceFilterPartyFlag then
      returnValue = true;
    elseif instanceType == "raid" and self.db.profile.instanceFilterRaidFlag then
      returnValue = true;
    elseif instanceType == "battleground" and self.db.profile.instanceFilterBgFlag then
      returnValue = true;
    end
  else
    -- non-in-instance type checking

    local groupType = self:getGroupType();
    self:debugMsg("  groupType: "..tostring(groupType), "blather");

    if groupType == "solo" and self.db.profile.groupFilterSoloFlag then
      returnValue = true;
    elseif groupType == "party" and self.db.profile.groupFilterPartyFlag then
      returnValue = true;
    elseif groupType == "raid" and self.db.profile.groupFilterRaidFlag then
      returnValue = true;
    end

  end

  self:debugMsg("  returnValue: "..tostring(returnValue), "blather");
  return returnValue;
end


function FlaskMinder:getGroupType()
  self:debugMsg("getGroupType()", "blather");

  local returnValue = "solo";
  local numRaidMembers = GetNumGroupMembers();
  local numPartyMembers = GetNumGroupMembers();

  self:debugMsg("  numRaidMembers: "..tostring(numRaidMembers), "blather");
  self:debugMsg("  numPartyMembers: "..tostring(numPartyMembers), "blather");

  if numRaidMembers and numRaidMembers > 1 then
    -- if this is nonzero, we're a raid
    returnValue = "raid";
  elseif numPartyMembers and numPartyMembers > 0 then
    -- if this is nonzero and we're NOT a raid, then we're a party
    returnValue = "party";
  end

  self:debugMsg("  returnValue: "..tostring(returnValue), "blather");
  return returnValue;
end


function FlaskMinder:checkBuffs( isInCombat )
  self:debugMsg("checkBuffs()", "debug");
  self:debugMsg("  info: "..tostring(info), "blather");
  self:debugMsg("  isInCombat: "..tostring(isInCombat), "blather");

  -- FIRST, check and see if our filters allow a check before continuing
  if not self:FilterCheck() then
    return
  end

  local niceName = "Your";
  local warnSoundPlayed = false; -- used to keep from spamming sounds
  local foodWarnMsg = "";
  local warnMsg = "";
  local EXPIRE_TIME = 0;

  if self.db.profile.timingExpireWarnFlag and self.db.profile.timingExpireWarnTime then
    EXPIRE_TIME = self.db.profile.timingExpireWarnTime;
  end

  -- get the actual list of player buffs
  local playerBuffs = self:getUnitBuffs( "player" );
  self:debugMsg("  playerBuffs: "..tostring(playerBuffs), "blather");

  if playerBuffs.name then
    niceName = tostring(playerBuffs.name).."'s";
    self:debugMsg("  niceName: "..tostring(niceName), "blather");
  end

  -- Handle food warnings
  self:debugMsg("Checking Food Buff", "debug");
  if self.db.profile.strictFoodFlag and not isInCombat then
    self:debugMsg("  strictFoodFlag set and not in combat", "debug");
    self:debugMsg("    playerBuffs table food info:", "blather");
    self:debugMsg("      foodName: ".. tostring(playerBuffs.foodName), "blather");
    self:debugMsg("      foodTimeLeft: ".. tostring(playerBuffs.foodTimeLeft), "blather");
    self:debugMsg("      foodFound: ".. tostring(playerBuffs.foodFound), "blather");
    self:debugMsg("      EXPIRE_TIME:"..tostring(EXPIRE_TIME), "blather");

    self:debugMsg("    checking foodFound", "debug");
    if not playerBuffs.foodFound then
      self:debugMsg("    FAILED foodFound check", "debug");
      -- NOT FOUND AT ALL
      foodWarnMsg = niceName.." food buff MISSING";

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(foodWarnMsg, 1.0, 0.0, 0.0, 5.0);
    else
      self:debugMsg("    PASSED foodFound, checking foodTimeLeft", "debug");
      if playerBuffs.foodFound and playerBuffs.foodTimeLeft < EXPIRE_TIME then
        self:debugMsg("    FAILED foodTimeLeft check", "debug");

        foodWarnMsg = niceName.." food buff will expire in "..self:secToHumanTime( playerBuffs.foodTimeLeft );

        if not warnSoundPlayed then
          self:playSoundByIndex(self.db.profile.defaultWarnSound);
          warnSoundPlayed = true;
        end
        UIErrorsFrame:AddMessage(foodWarnMsg, 1.0, 1.0, 0.5, 5.0);
      end  -- foodTimeLeft
    end
  end  -- food checks

  -- HANDLE FLASKS/ELIXIRS
  --
  -- FLASK FOUND SECTION
  --
  self:debugMsg("Checking Flasks and/or Elixirs", "debug");
  if playerBuffs.flaskFound then
    self:debugMsg("  in flaskFound section ", "debug");
    self:debugMsg("      EXPIRE_TIME:"..tostring(EXPIRE_TIME), "blather");

    -- flask found, don't bother with elixirs at all, but DO check for flask warning
    self:debugMsg("  checking flaskTimeLeft", "debug");
    if not playerBuffs.flaskTimeLeft or playerBuffs.flaskTimeLeft < EXPIRE_TIME then
      self:debugMsg("    FAILED flaskTimeLeft check", "debug");
      warnMsg = niceName.." "..tostring(playerBuffs.flaskName).." will expire in "..self:secToHumanTime( playerBuffs.flaskTimeLeft );

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
    end
  --
  -- NOTHING FOUND SECTION
  --
  elseif not playerBuffs.flaskFound and not playerBuffs.gExFound and not playerBuffs.bExFound then
    self:debugMsg("  in not flaskFound AND not gExFound AND not bExFound section", "debug");

    -- ABSOLUTELY NOTHING found, SCREAM
    warnMsg = tostring(playerBuffs.name).." Has no flask or elixirs";

    if not warnSoundPlayed then
      self:playSoundByIndex(self.db.profile.defaultWarnSound);
      warnSoundPlayed = true;
    end
    UIErrorsFrame:AddMessage(warnMsg, 1.0, 0.0, 0.0, 5.0);
  --
  -- STRICT ELIXIRS SECTION
  --
  elseif self.db.profile.strictElixirFlag then
    self:debugMsg("  in strictElixirFlag section", "debug");

    -- We have no flask, but we may have a guardian or battle elixir
    --   SCREAM if we have nothing
    --   also, throw out warnings for whichever they have

    --
    -- STRICT GUARDIAN ELIXIR SECTION
    --
    self:debugMsg("    checking gExFound", "debug");
    if not playerBuffs.gExFound then
      self:debugMsg("    FAILED gExFound", "debug");

      warnMsg = tostring(playerBuffs.name).." Has no GUARDIAN elixir";

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
    elseif playerBuffs.gExFound and playerBuffs.gExTimeLeft < EXPIRE_TIME then
      self:debugMsg("    PASSED gExFound, but gExTimeLeft below threshhold", "debug");
      -- warn the guardian elixir is running out
      warnMsg = niceName.." "..tostring(playerBuffs.gExName).." will expire in "..self:secToHumanTime( playerBuffs.gExTimeLeft );

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
    end

    --
    -- STRICT BATTLE ELIXIR SECTION
    --
    self:debugMsg("    checking bExFound", "debug");
    if not playerBuffs.bExFound then
      self:debugMsg("    FAILED bExFound", "debug");
      warnMsg = tostring(playerBuffs.name).." Has no BATTLE elixir";

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
    elseif playerBuffs.bExFound and playerBuffs.bExTimeLeft < EXPIRE_TIME then
      self:debugMsg("    PASSED bExFound, but gExTimeLeft below threshhold", "debug");
      -- warn the guardian elixir is running out
      warnMsg = niceName.." "..tostring(playerBuffs.bExName).." will expire in "..self:secToHumanTime( playerBuffs.bExTimeLeft );

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
    end
  else
    self:debugMsg("  in unstrict elixir checks section", "debug");
    -- UNSTRICT checks

    self:debugMsg("    checking gExFound AND bExFound", "debug");
    if not playerBuffs.gExFound and not playerBuffs.bExFound then
      self:debugMsg("      FAILED check, both missing", "debug");
      -- if we got this far, we know we have no flask, and now, we know we have no elixirs either

      -- ABSOLUTELY NOTHING found, SCREAM
      warnMsg = tostring(playerBuffs.name).." Has no flask or elixirs";

      if not warnSoundPlayed then
        self:playSoundByIndex(self.db.profile.defaultWarnSound);
        warnSoundPlayed = true;
      end
      UIErrorsFrame:AddMessage(warnMsg, 1.0, 0.0, 0.0, 5.0);

    else
      self:debugMsg("      PASSED check, at least one elixir present... checking expirations", "debug");

      -- ok, something's up... make sure its not low

      -- UNSTRICT GUARDIAN ELIXIR (only warn if its there but low)
      self:debugMsg("    checking gExTimeLeft", "debug");
      if playerBuffs.gExFound and playerBuffs.gExTimeLeft < EXPIRE_TIME then
        self:debugMsg("    FAILED gExTimeLeft check", "debug");
        -- warn the guardian elixir is running out
        warnMsg = niceName.." "..tostring(playerBuffs.gExName).." will expire in "..self:secToHumanTime( playerBuffs.gExTimeLeft );

        if not warnSoundPlayed then
          self:playSoundByIndex(self.db.profile.defaultWarnSound);
          warnSoundPlayed = true;
        end
        UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
      end

      -- UNSTRICT BATTLE ELIXIR (only warn if its there but low)
      self:debugMsg("    checking bExTimeLeft", "debug");
      if playerBuffs.bExFound and playerBuffs.bExTimeLeft < EXPIRE_TIME then
        self:debugMsg("    FAILED bExTimeLeft check", "debug");
        -- warn the guardian elixir is running out
        warnMsg = niceName.." "..tostring(playerBuffs.bExName).." will expire in "..self:secToHumanTime( playerBuffs.bExTimeLeft );

        if not warnSoundPlayed then
          self:playSoundByIndex(self.db.profile.defaultWarnSound);
          warnSoundPlayed = true;
        end
        UIErrorsFrame:AddMessage(warnMsg, 1.0, 1.0, 0.5, 5.0);
      end

    end -- end if neither elixir else if low elixir

  end
  warnSoundPlayed = false
end -- end of checkBuffs



--[[
  Much of the hard work was already done in AntiSlack by Battleguard of Balnazzar.

  BuffCheck()

  Checks the current UID for Food and Flask / Elixirs and returns table:

  returnTable = {
  ["UID"] = string,
  ["dead"] = bool,
  ["name"] = string,
  ["class"] = string,
  ["r"] = int,
  ["g"] = int,
  ["b"] = int,

  ["foodFound"] = bool,
  ["foodName"] = string,
  ["foodTimeLeft"] = int (sec),

  ["flaskFound"] = bool,
  ["flaskName"] = string,
  ["flaskTimeLeft"] = int (sec),

  ["gExFound"] = bool,
  ["gExName"] = string,
  ["gExTimeLeft"] = int (sec),

  ["bExFound"] = bool,
  ["bExName"] = string,
  ["bExTimeLeft"] = int (sec),
  }

]]--
function FlaskMinder:getUnitBuffs(info, UID)

  -- if called without UID, then we assume it's self
  if UID == nil then
    UID = "player";
  end

  local returnTable = {};
  -- Initializing the returnTable values
  returnTable.UID = UID;
  returnTable.dead = UnitIsDead(UID);
  returnTable.name = UnitName(UID);
  returnTable.class = ({UnitClass(UID)})[2];
  returnTable.r = RAID_CLASS_COLORS[returnTable.class].r;
  returnTable.g = RAID_CLASS_COLORS[returnTable.class].g;
  returnTable.b = RAID_CLASS_COLORS[returnTable.class].b;

  returnTable.foodFound = false;
  returnTable.foodName = "NONE";
  returnTable.foodTimeLeft = 0;
  returnTable.flaskFound = false;
  returnTable.flaskName = "NONE";
  returnTable.flaskTimeLeft = 0;
  returnTable.gExFound = false;
  returnTable.gExName = "NONE";
  returnTable.gExTimeLeft = 0;
  returnTable.bExFound = false;
  returnTable.bExName = "NONE";
  returnTable.bExTimeLeft = 0;

  -- Iterate through the buffs and get time left / existence on flasks, elixirs, etc...
  for j = 1, 40 do
    local buffname, _, bufficon, _, _, _, timeleft = UnitBuff(UID, j);

    if buffname then
      if not returnTable.foodFound and buffname == L["WELL_FED"] then
        returnTable.foodName = L["WELL_FED"];
        returnTable.foodTimeLeft = self:expTimeToSeconds( timeleft );
        returnTable.foodFound = true;
      elseif not returnTable.flaskFound and self:isStringInTable(buffname, masterList.FEx) then
        returnTable.flaskName = buffname;
        returnTable.flaskTimeLeft = self:expTimeToSeconds( timeleft );
        returnTable.flaskFound = true;
        -- Clearing the other values cuz flask is king
        returnTable.gExFound = false;
        returnTable.gExName = "NONE";
        returnTable.gExTimeLeft = 0;
        returnTable.bExFound = false;
        returnTable.bExName = "NONE";
        returnTable.bExTimeLeft = 0;
      elseif not returnTable.flaskFound and not returnTable.gExFound and self:isStringInTable(buffname, masterList.GEx) and not self:isStringInTable(bufficon, masterList.XEx) then
        returnTable.gExName = buffname;
        returnTable.gExTimeLeft = self:expTimeToSeconds( timeleft );
        returnTable.gExFound = true;
      elseif not returnTable.flaskFound and not returnTable.bExFound and self:isStringInTable(buffname, masterList.BEx) and not self:isStringInTable(bufficon, masterList.XEx) then
        returnTable.bExName = buffname;
        returnTable.bExTimeLeft = self:expTimeToSeconds( timeleft );
        returnTable.bExFound = true;
      elseif returnTable.foodFound and ( flaskFound or ( gExFound and bExFound ) ) then
        -- stop looking, we have all that we're after
        break;
      end
    else
      break;
    end
  end

  -- Always sending back a valid returnTable
  return returnTable;
end




-- ------------------------------------------------
-- EVENT HANDLERS
-- ------------------------------------------------


-- ------------------------------------------------
-- HOOKED FUNCTIONS
-- ------------------------------------------------


-- ------------------------------------------------
-- COMMUNICATIONS HANDLER
-- ------------------------------------------------

-- --
-- -- Handles received commands
-- --
-- -- NOTE: This should REALLY get broken up into separate items / tableize
-- --
-- function FlaskMinder:OnCommReceived(prefix, message, distribution, target)
--   -- Deserialize incoming message
--   local success, o = self:Deserialize(message)
--   if (self.db.profile.debugFlag) then
--     self:debugMsg("OnCommReceived():: ENGAGED", "debug")
--     self:debugMsg("  prefix:"..tostring(prefix), "blather")
--     self:debugMsg("  message:"..tostring(message), "blather")
--     self:debugMsg("  distribution:"..tostring(distribution), "blather")
--     self:debugMsg("  target:"..tostring(target), "blather")
--     self:debugMsg("  player:"..UnitName("player"), "blather")
--     self:debugMsg("  Deserialize success:"..tostring(success), "blather")
--     self:debugMsg("  Message Content:"..tostring(o), "blather")
--   end -- end if debugFlag
--
--   -- don't do anyting if we could not deserialize
--   if (success == false) then
--     self:debugMsg("Failed to deserialize the message - OnCommReceived can not process any further", "error")
--     return -- Failure
--   else
--     --
--     -- TEMPLATE - Not actually used
--     --
--     if (o["op"] == "foo") then
--       if (self.db.profile.actionFlag) then
--         self:debugMsg("FOO op ENGAGED", "debug")
--
--         -- Put any extra conditions here
--         if ("someCondition" == "some value") then
--           self:debugMsg("debug_text_here", "blather")
--           return -- do nothing
--         else
--           -- do the action
--           self:debugMsg("debug_text_here", "blather")
--
--           -- actual command such as TakeTaxiNode(o["node"], "noComm")
--         end -- ending extra conditions
--       end -- if gossipFlag
--     end -- end if op == foo
--     --
--     -- END TEMPLATE
--     --
--
--   end -- if success==false
-- end -- function OnCommReceived


-- --
-- -- Wraps up Remote procedure call commands with a "nocomm" throttler
-- --
-- function FlaskMinder:rpcCommandSender(prefix, text, distribution, target, prio, noComm)
--   --debug
--   if (self.db.profile.debugFlag) then
--     self:debugMsg("rpcCommandSender()", "debug")
--     self:debugMsg("  prefix: "..tostring(prefix), "blather")
--     self:debugMsg("  text: "..tostring(text), "blather")
--     self:debugMsg("  distribution: "..tostring(distribution), "blather")
--     self:debugMsg("  target: "..tostring(target), "blather")
--     self:debugMsg("  prio: "..tostring(prio), "blather")
--     self:debugMsg("  noComm flag: "..tostring(noComm), "blather")
--   end
--
--   -- New throttling - DO NOT send msg unless noComm is nil
--   if (noComm) then
--     self:debugMsg("noComm flag IS set, NOT sending command", "blather")
--     -- Teh Gogglez - They do NOTHING!
--     return
--   else
--     self:debugMsg("noComm flag NOT set, sending command", "blather")
--     if (GetNumPartyMembers() == 0 and (distribution == "RAID" or distribution == "PARTY")) then
--       -- NOT in party, but trying to send to party - modify distirbution and target
--       distribution = "WHISPER"
--       target = GetUnitName("player")
--     end
--     self:SendCommMessage(prefix, text, distribution, target, prio)
--   end
-- end


-- ------------------------------------------------
-- UTILITY FUNCTIONS
-- ------------------------------------------------
function FlaskMinder:helpCommand( input )

  self:Print( L["HELP_MENU"] );
end


function FlaskMinder:groupTypeCheck()
  self:debugMsg("groupTypeCheck() Initiated...");

  -- local lootMethod, partyMaster, raidMaster = GetLootMethod();
  local numRaidMembers = GetNumRaidMembers();
  local numPartyMembers = GetNumPartyMembers();
  local inInstance, instanceType = IsInInstance();

  self:debugMsg("  Raw Group Check Info");
  -- self:debugMsg("  lootMethod: "..tostring(lootMethod), "debug");
  -- self:debugMsg("  partyMaster: "..tostring(partyMaster), "debug");
  -- self:debugMsg("  raidMaster: "..tostring(raidMaster), "debug");
  self:debugMsg("    numRaidMembers: "..tostring(numRaidMembers), "debug");
  self:debugMsg("    numPartyMembers: "..tostring(numPartyMembers), "debug");
  self:debugMsg("    inInstance: "..tostring(inInstance), "debug");
  self:debugMsg("    instanceType: "..tostring(instanceType), "debug");

end


function FlaskMinder:print_r( targetTable )
  self:debugMsg("DUMPING contents of table"..tostring(targetTable), "blather");
  local returnString = "";
  for k,v in ipairs( targetTable ) do
    self:debugMsg("  Found Key: "..tostring(k), "blather");
    self:debugMsg("  Found Value: "..tostring(v), "blather");
    returnString = returnString.."["..tostring(k).."] = "..tostring(v).."\n";
  end
  return returnString;
end


--[[
  secToHumanTime is a simple funciton to take a value in seconds and return
  a more human readable time format.

  Depending on the time left, we will return one of the three
  (where X is number of hours, Y is number of minites, and Z is num of seconds)
    "Xh Ym"
    "Ym"
    "Zs"
]]--
function FlaskMinder:secToHumanTime( seconds )
  local returnVal = "0s"
  local hrs = 0
  local mins = 0
  local secs = 0

  if seconds then  -- avoids nil errors
    if seconds < 60 then -- less than a minute, break into seconds
      secs = seconds
    elseif seconds < 3600 then -- less than an hour (but more than a minute) use minutes
      mins = math.floor( 1 + ( seconds / 60 ) )
    else -- more than an hour use hours/mins
      -- get raw hours
      hrs = math.floor( seconds / 3600 )
      -- get raw mins
      mins = math.floor( 1 + ( ( seconds - ( hrs * 3600 ) ) / 60 ) )
    end
  end

  -- format up the results nicely for return
  if hrs > 0 then
    returnVal = string.format( "%u h, %u m", hrs, mins )
  elseif mins > 0 then
    returnVal = string.format( "%u m", mins, secs )
  else
    returnVal = string.format( "%u s", secs )
  end

  return returnVal
end


function FlaskMinder:expTimeToSeconds( timeValue )
  return math.floor(-1*(GetTime()-timeValue))
end


-- Checks if a string is in a table
-- Borrowed from Battleguard's AntiSlack
function FlaskMinder:isStringInTable( targetString, targetTable )
  local stringFound = false

  -- loop through all values
  for i = 1, #targetTable do
    if targetTable[i] == targetString then
      stringFound = true
      break
    end
  end

  return stringFound
end

------------------
-- Sound handling
------------------

--
-- Plays a chosen sound from soundList by its FlaskMinder option
--
function FlaskMinder:soundCheck(key)
  self:debugMsg("soundCheck()", "debug")
  self:debugMsg("  key: "..tostring(key), "debug")
  -- need nil check to keep uglyness from happening
  if (key ~= nil) then
    self:playSoundByIndex(self.db.profile[key])
  end
end

--
-- Plays a chosen sound from soundList by its index (in soundList)
--
function FlaskMinder:playSoundByIndex(index)
  self:debugMsg("playSoundByIndex()", "debug")
  self:debugMsg("  index:"..tostring(index), "blather")
  -- check if USE DEFAULT
  if (index == #soundList) then
    self:debugMsg("  USE DEFAULT detected, altering choice...", "blather")
    -- alter the index to the default
    index = self.db.profile.defaultWarnSound
    self:debugMsg("    new index:"..tostring(index), "blather")
  end

  -- 1 will always be NONE, so only play if it's something else
  if (index > 1) then
    PlaySoundFile(self:getSoundPathByIndex(index))
    self:debugMsg("Playing sound "..tostring(self:getSoundNameByIndex(index)), "debug")
  else
    self:debugMsg("  Not playing sound due to user selection", "blather")
  end
end

--
-- Returns the name of the item defined in soundList given the soundList index
--
function FlaskMinder:getSoundNameByIndex(index)
  return soundList[index].name
end

--
-- Returns the path of the item defined in soundList given the soundList index
--
function FlaskMinder:getSoundPathByIndex(index)
  return soundList[index].path
end

--
-- Wrapper for soundList to make the type of array needed by AceConfig select
--
-- NOTE: If passed any non-false value in skipDefault, then it removes the last
--       entry which should always be "USE DEFAULT". This is needed for the
--       config section of the default sound so it doesn't end up referring
--       to itself.
function FlaskMinder:getSoundSelectTable(skipDefault)
  self:debugMsg("getSoundSelectTable()", "debug")
  self:debugMsg("  skipDefault:"..tostring(skipDefault), "blather")

  local returnTable = {}
  -- turn the soundList into a flat table
  for k,v in ipairs(soundList) do
    --[[ -- not used
    self:debugMsg("adding to returnTable", "debug")
    self:debugMsg("  key: "..tostring(k), "debug")
    self:debugMsg("  val: "..tostring(v), "debug")
    self:debugMsg("  val.name: "..tostring(v.name), "debug")
    self:debugMsg("  val.path: "..tostring(v.path), "debug")
    ]]
    table.insert(returnTable, k, v.name)
  end

  -- Handle removing the last entry (should always be "USE DEFAULT")
  if (skipDefault ~= nil and skipDefault ~= false) then
    self:debugMsg("  skipDefault set... removing index: "..tostring(#returnTable), "blather")
    -- we don't want the default sound to be able to use "USE DEFAULT"
    table.remove(returnTable, #returnTable)
  end

  -- Pass back the resulting table we created
  return returnTable
end


--
-- Takes a raw Amount of money (WOW always just passes costs in copper and
-- returns either formatted text "Xg Xs Xc" or three component values g,s,c
--
-- @param int rawAmount The amount of money (in copper) to parse
-- @param string outputType Controls the form of output (currently only text or default)
-- @return string  (if outputType == "text")
-- @return int,int,int  g,s,c  Values for Gold, Silver, and Copper respectively
function FlaskMinder:copperToCurrency(rawAmount, outputType)
  -- calculate amounts
  -- raw amount is copper - 1g = 10,000c, so just get raw/10,000 and discard remainder
  local g = math.floor( rawAmount / 10000 )
  -- raw amount is copper, 1s = 100 c... subtract g*10,000 copper and do division, discard remainder
  local s = math.floor( ( rawAmount - ( g * 10000 ) ) / 100 )
  -- by doing modulus of rawAmount and 100, we just get copper left
  local c = rawAmount % 100

  -- format return
  if (outputType == "text") then
    -- output will be string formatted as  Xg Xs Xc
    -- return tostring(g).."g "..tostring(s).."s "..tostring(c).."c"
    return string.format("%ug %us %uc", g,s,c)
  else
    -- three separate values returned by default... gold, silver, copper
    return g,s,c
  end
end


--
-- Debugging and console message handling
--
function FlaskMinder:debugMsg(text, level)
  if (level == nil) then
    return -- do nothing
  elseif (level == "error") then
    PlaySound("RaidWarning");
    UIErrorsFrame:AddMessage(text, 1.0, 0.0, 0.0, 5.0)
  elseif (level == "warn") then
    PlaySoundFile(self:getSoundPathByIndex(self.db.profile.defaultWarnSound))
    UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0.5, 5.0)
  elseif (level == "notice") then
    self:Print(level..": "..text)
  elseif (level == "debug" and (self.db.profile.debugFlag or self.db.profile.blatherFlag)) then
    self:Print(level..": "..text)
  elseif (level == "blather" and self.db.profile.blatherFlag) then
    self:Print(level..": "..text)
  end
end
