--[[
FlaskMinder Spanish language localization

Author: DigitalSorceress
Date: 2014/10/12
Version: 6.0.2.000
]]

-- Sets up the AceLocale for this addon with esMX as localization
local L = LibStub("AceLocale-3.0"):NewLocale("FlaskMinder", "esMX", false);
if not L then return end

--------------------------------------------------------------------------------
-- Chat commands
--------------------------------------------------------------------------------
L["FULL_SLASH_CMD"] = "flaskminder"
L["SHORT_SLASH_CMD"] = "fm"
--------------------------------------------------------------------------------

L["BLATHER_DESC"] = "Toggles whether to output massively chatty debugging messages or not." -- Requires localization
L["BLATHER_NAME"] = "Show Blather Level" -- Requires localization
L["DEBUG_DESC"] = "Toggles whether to output debugging messages or not." -- Requires localization
L["DEBUG_NAME"] = "Show Debug Level" -- Requires localization
L["DEBUG_OPTIONS_NAME"] = "Debugging Options" -- Requires localization
L["DEFAULT_SOUND_GROUP_DESC"] = [=[
This is the sound that will play when certain important events happen within FlaskMinder.

Simply set to "none" to turn off the sound features. The "Default Sound" is the standard "Raid Warn" sound.
]=] -- Requires localization
L["DEFAULT_SOUND_GROUP_NAME"] = "Warning Sound" -- Requires localization
L["FILTER_OPTIONS_DESC"] = [=[
These are options to control the group/instance conditions under which you will be alerted by FlaskMinder.

Note that Instance options take precidense over the group options, so checking notify in raid group, but NOT checking instance will mean that you will only be notified when you are in a raid group, but NOT in an instance.
]=] -- Requires localization
L["FILTER_OPTIONS_NAME"] = "Instance / Group Filters" -- Requires localization
L["GROUP_FILTER_GROUP_DESC"] = [=[
These apply when you are NOT in an instance or battleground.

Check those grooup types (or solo) where you want to have FlaskMinder remind you about your consumables when NOT in instances (or battlegrounds).
]=] -- Requires localization
L["GROUP_FILTER_GROUP_NAME"] = "Group Filters" -- Requires localization
L["GROUP_FILTER_PARTY_DESC"] = "Check this if you want FlaskMinder warnings when in a (non-raid)party" -- Requires localization
L["GROUP_FILTER_PARTY_NAME"] = "Party" -- Requires localization
L["GROUP_FILTER_RAID_DESC"] = "Check this if you want FlaskMinder warnings when in a raid group" -- Requires localization
L["GROUP_FILTER_RAID_NAME"] = "Raid" -- Requires localization
L["GROUP_FILTER_SOLO_DESC"] = "Check this if you want FlaskMinder warnings even when you are on your own" -- Requires localization
L["GROUP_FILTER_SOLO_NAME"] = "Solo" -- Requires localization
L["HELP_MENU"] = [=[
Help Menu
------------------------------
COMMANDS:

  Bring up the main options window
  /flaskminder
  /fm

  Show this help menu
  /flaskminder help

  Force immediate buff check
  /flaskminder check
  /flaskminder force
]=] -- Requires localization
L["INSTANCE_FILTER_BG_DESC"] = "In a battleground (though NOT arenas)" -- Requires localization
L["INSTANCE_FILTER_BG_NAME"] = "Battleground" -- Requires localization
L["INSTANCE_FILTER_GROUP_DESC"] = [=[
Check the box to ENABLE warnings when in instances.

Regardless of your group type (solo, 5 man party, or raid group), FlaskMinder will not warn you about your consumables when in an instance, raid, or battleground unless the appropriate boxes are checked.
]=] -- Requires localization
L["INSTANCE_FILTER_GROUP_NAME"] = "Instance Filters" -- Requires localization
L["INSTANCE_FILTER_PARTY_DESC"] = "In a 5-man instance ... regardless of group type or difficulty setting" -- Requires localization
L["INSTANCE_FILTER_PARTY_NAME"] = "5-man" -- Requires localization
L["INSTANCE_FILTER_RAID_DESC"] = "In a raid instance (normal OR Heroic)" -- Requires localization
L["INSTANCE_FILTER_RAID_NAME"] = "Raid" -- Requires localization
L["MAIN_DESCRIPTION"] = [=[FlaskMinder es una sencilla utilidad que te avisará cuando el matraz (de batalla / elixir guardián) está a punto de expirar, y de nuevo cuando ha expirado.

Actualmente también capaz de rastrear los aficionados de alimentos, pero no ha añadido poisions Rogue todavía.

NOTA: Yo no hablo español, por eso se han basado en traducción de Google y es.wowhead.com para mi localización esES.

Por favor, visite http://www.wowace.com/addons/flaskminder/localization/ para ayudarme a dejar de despiece su idioma.]=] -- Needs review
L["PICK_SOUND_DESC"] = "Choose a sound to accompany this option." -- Requires localization
L["PICK_SOUND_NAME"] = "Pick a Sound" -- Requires localization
L["PICK_SOUND_TEST"] = "Test Chosen Sound" -- Requires localization
L["SOUND_OPTIONS_NAME"] = "Sound Options" -- Requires localization
L["STRICT_ELIXIR_DESC"] = "Toggles whether to insist upon TWO elixirs (battle AND guardian)." -- Requires localization
L["STRICT_ELIXIR_NAME"] = "Require TWO Elixirs" -- Requires localization
L["STRICT_FOOD_DESC"] = "Toggles whether to remind about food buff." -- Requires localization
L["STRICT_FOOD_NAME"] = "Require Food Buff" -- Requires localization
L["STRICT_GROUP_DESC"] = [=[
Use these settings to control how strict FlaskMinder is.

You can choose whether to watch for food buffs as well as whether two elixirs are required (when you dont have flask
]=] -- Requires localization
L["STRICT_GROUP_NAME"] = "Strictness" -- Requires localization
L["TIMING_EXPIRE_WARN_FLAG_DESC"] = "Check this to allow Flask Minder to warn you before your buffs expire" -- Requires localization
L["TIMING_EXPIRE_WARN_FLAG_NAME"] = "Enable Expiration Warnings" -- Requires localization
L["TIMING_EXPIRE_WARN_GROUP_DESC"] = "Settings for warning you when food and/or flasks/elixirs are about to expire" -- Requires localization
L["TIMING_EXPIRE_WARN_GROUP_NAME"] = "Expiration Warnings" -- Requires localization
L["TIMING_EXPIRE_WARN_TIME_DESC"] = "How long before buffs expire do you want to be warned?" -- Requires localization
L["TIMING_EXPIRE_WARN_TIME_NAME"] = "Expiration Time" -- Requires localization
L["TIMING_MASTER_TIMER_FREQ_DESC"] = "How often you want the timer to check for buffs" -- Requires localization
L["TIMING_MASTER_TIMER_FREQ_NAME"] = "Check Frequency" -- Requires localization
L["TIMING_MASTER_TIMER_GROUP_DESC"] = [=[
The master timer value determines (if the "enable timer" option is set in the main config menu) how frequently FlaskMinder will check on your buff status regardless of whether you are entering/exiting combat.

This feature is somewhat experimental and may cause "spammy" behavior.
]=] -- Requires localization
L["TIMING_MASTER_TIMER_GROUP_NAME"] = "Master Timer" -- Requires localization
L["TIMING_OPTIONS_DESC"] = [=[
Configuration of various time-based options.
]=] -- Requires localization
L["TIMING_OPTIONS_NAME"] = "Timing Options" -- Requires localization
L["UPDATE_ENTER_COMBAT_DESC"] = "Toggles whether to Check your buffs upon entering combat." -- Requires localization
L["UPDATE_ENTER_COMBAT_NAME"] = "Enter Combat" -- Requires localization
L["UPDATE_EXIT_COMBAT_DESC"] = "Toggles whether to Check your buffs upon exiting combat." -- Requires localization
L["UPDATE_EXIT_COMBAT_NAME"] = "Exit Combat" -- Requires localization
L["UPDATE_GROUP_DESC"] = [=[
Use these settings to control how often / when FlaskMinder will check your buffs.

This addon could be "spammy" if you enable all these options, but players have different preferences about when / how often they want checks (and depenging on buff status, the associated warnings).
]=] -- Requires localization
L["UPDATE_GROUP_NAME"] = "Update Options" -- Requires localization
L["UPDATE_READY_CHECK_DESC"] = [=[
Toggles whether or not to check when you get a 'ready check' from a party/raid leader.
]=] -- Requires localization
L["UPDATE_READY_CHECK_NAME"] = "Ready Check" -- Requires localization
L["UPDATE_USE_TIMER_DESC"] = [=[
Toggles whether to use the timer (defined in the timing options configuration panel) as an update checker.
]=] -- Requires localization
L["UPDATE_USE_TIMER_NAME"] = "Enable Timer" -- Requires localization
L["VEHICLE_FILTER_DESC"] = [=[
Toggles whether or not to check when you are riding in a vehicle.
]=] -- Requires localization
L["VEHICLE_FILTER_GROUP_DESC"] = [=[
Avoids spammishness in Flame Leviathan, Oc, EoE, ToC, and other places/times when you are riding in a vehicle and really would not benefit from or be able to do anything about it. Shouts out to Eviloz for this awesome suggestion.
]=] -- Requires localization
L["VEHICLE_FILTER_GROUP_NAME"] = "Vehicle Filter" -- Requires localization
L["VEHICLE_FILTER_NAME"] = "Check Even In Vehicle" -- Requires localization


--------------------------------------------------------------------------------
-- The lists of flasks were already figured out by Taken from AntiSlack by Battleguard of Balnazzar
--------------------------------------------------------------------------------

-- Flasks. The description fields are for the BUFFS given by these flasks, NOT from the actual flask item (though in some cases they do match).
-- WARLORDS of DRAENOR
L["F_DRAENIC_AGILITY_FLASK"]           = "Draenic Agility Flask"           -- http://wod.wowhead.com/spell=156073
L["F_DRAENIC_INTELLECT_FLASK"]         = "Draenic Intellect Flask"         -- http://wod.wowhead.com/spell=156070
L["F_DRAENIC_STAMINA_FLASK"]           = "Draenic Stamina Flask"           -- http://www.wowhead.com/spell=156077
L["F_DRAENIC_STRENGTH_FLASK"]          = "Draenic Strength Flask"          -- http://wod.wowhead.com/spell=156071
L["F_GREATER_DRAENIC_AGILITY_FLASK"]   = "Greater Draenic Agility Flask"   -- http://wod.wowhead.com/spell=156064
L["F_GREATER_DRAENIC_INTELLECT_FLASK"] = "Greater Draenic Intellect Flask" -- http://www.wowhead.com/spell=156079
L["F_GREATER_DRAENIC_STAMINA_FLASK"]   = "Greater Draenic Stamina Flask"   -- http://wod.wowhead.com/spell=156084
L["F_GREATER_DRAENIC_STRENGTH_FLASK"]  = "Greater Draenic Strength Flask"  -- http://wod.wowhead.com/spell=156080
-- MISTS of PANDARIA
L["F_FLASK_OF_FALLING_LEAVES"]         = "Frasco de hojas otoñales"           -- http://es.wowhead.com/spell=105693
L["F_FLASK_OF_SPRING_BLOSSOMS"]        = "Frasco de flores primaverales"      -- http://es.wowhead.com/spell=105689
L["F_FLASK_OF_THE_WARM_SUN"]           = "Frasco del sol cálido"              -- http://es.wowhead.com/spell=105691
L["F_FLASK_OF_THE_EARTH"]              = "Frasco de la Tierra"                -- http://es.wowhead.com/spell=105694
L["F_FLASK_OF_WINTERS_BITE"]           = "Frasco de inclemencia invernal"     -- http://es.wowhead.com/spell=105696
-- CATACLYSM
L["F_ENHANCED_INTELLECT"]              = "Intelecto mejorado"                 -- http://es.wowhead.com/spell=79640
L["F_ENHANCED_STRENGTH"]               = "Fuerza mejorada"                    -- http://es.wowhead.com/spell=79638
L["F_ENHANCED_AGILITY"]                = "Agilidad mejorada"                  -- http://es.wowhead.com/spell=79639
L["F_FLASK_OF_FLOWING_WATER"]          = "Frasco de agua corriente"           -- http://es.wowhead.com/item=67438  
L["F_FLASK_OF_STEELSKIN"]              = "Frasco de piel de acero"            -- http://es.wowhead.com/item=58085  
L["F_FLASK_OF_THE_DRACONIC_MIND"]      = "Frasco de la mente dracónica"       -- http://es.wowhead.com/item=58086  
L["F_FLASK_OF_THE_WINDS"]              = "Frasco de los vientos"              -- http://es.wowhead.com/item=58087  
L["F_FLASK_OF_TITANIC_STRENGTH"]       = "Frasco de la fuerza titánica"       -- http://es.wowhead.com/item=58088  
-- PRE-CATA
L["F_BLINDING_LIGHT_OF_SHATTRATH"]     = "Luz cegadora de Shattrath"          -- http://es.wowhead.com/?spell=46839
L["F_CHROMATIC_RESISTANCE"]            = "Resistencia cromática"              -- http://es.wowhead.com/?spell=17629
L["F_CHROMATIC_WONDER"]                = "Maravilla cromática"                -- http://es.wowhead.com/?spell=42735
L["F_DISTILLED_WISDOM"]                = "Sabiduría destilada"                -- http://es.wowhead.com/?spell=17627
L["F_FLASK_OF_BLINDING_LIGHT"]         = "Frasco de Luz cegadora"             -- http://es.wowhead.com/?spell=28521
L["F_FLASK_OF_ENDLESS_RAGE"]           = "Frasco de ira infinita"             -- http://es.wowhead.com/?spell=53760
L["F_FLASK_OF_FORTIFICATION"]          = "Frasco de fortificación"            -- http://es.wowhead.com/?spell=28518
L["F_FLASK_OF_MIGHTY_RESTORATION"]     = "Frasco de restauración poderosa"    -- http://es.wowhead.com/?spell=28519
L["F_FLASK_OF_PURE_DEATH"]             = "Flask of Pure Death"                -- http://es.wowhead.com/?spell=28540
L["F_FLASK_OF_PURE_MOJO"]              = "Frasco de muerte pura"              -- http://es.wowhead.com/?spell=54212
L["F_FLASK_OF_RELENTLESS_ASSAULT"]     = "Frasco de asalto incansable"        -- http://es.wowhead.com/?spell=28520
L["F_FLASK_OF_STONEBLOOD"]             = "Frasco de sangrepiedra"             -- http://es.wowhead.com/?spell=53758
L["F_FLASK_OF_THE_FROST_WYRM"]         = "Frasco de la vermis de escarcha"    -- http://es.wowhead.com/?spell=53755
L["F_FLASK_OF_THE_NORTH"]              = "Frasco del norte"                   -- http://es.wowhead.com/?spell=67019
L["F_FLASK_OF_THE_TITANS"]             = "Frasco de los titanes"              -- http://es.wowhead.com/?spell=17626
L["F_FORTIFICATION_OF_SHATTRATH"]      = "Fortificación de Shattrath"         -- http://es.wowhead.com/?spell=41609
L["F_LESSER_FLASK_OF_TOUGHNESS"]       = "Elixir de consistencia inferior"    -- http://es.wowhead.com/?spell=53752
L["F_MIGHTY_RESTORATION_OF_SHATTRATH"] = "Restauración poderosa de Shattrath" -- http://es.wowhead.com/?spell=41610
L["F_PETRIFICATION"]                   = "Petrificación"                      -- http://es.wowhead.com/?spell=17624
L["F_PURE_DEATH_OF_SHATTRATH"]         = "Muerte pura de Shattrath"           -- http://es.wowhead.com/?spell=46837
L["F_RELENTLESS_ASSAULT_OF_SHATTRATH"] = "Asalto despiadado de Shattrath"     -- http://es.wowhead.com/?spell=41608
L["F_SUPREME_POWER"]                   = "Poder supremo"                      -- http://es.wowhead.com/?spell=17628
L["F_SUPREME_POWER_OF_SHATTRATH"]      = "Poder supremo de Shattrath"         -- http://es.wowhead.com/?spell=41611
L["F_UNSTABLE_FLASK_OF_THE_BANDIT"]    = "Frasco inestable del bandido"       -- http://es.wowhead.com/?spell=40567
L["F_UNSTABLE_FLASK_OF_THE_BEAST"]     = "Frasco inestable de la bestia"      -- http://es.wowhead.com/?spell=40572
L["F_UNSTABLE_FLASK_OF_THE_ELDER"]     = "Frasco inestable del anciano"       -- http://es.wowhead.com/?spell=40568
L["F_UNSTABLE_FLASK_OF_THE_PHYSICIAN"] = "Frasco inestable del médico"        -- http://es.wowhead.com/?spell=40573
L["F_UNSTABLE_FLASK_OF_THE_SOLDIER"]   = "Frasco inestable del soldado"       -- http://es.wowhead.com/?spell=40575
L["F_UNSTABLE_FLASK_OF_THE_SORCERER"]  = "Frasco inestable del hechicero"     -- http://es.wowhead.com/?spell=40576

-- Guardian Elixirs. The description fields are for the BUFFS given by these elixirs, NOT from the actual elixir item.
-- WARLORDS of DRAENOR
-- MISTS OF PANDARIA
L["G_ELIXIR_OF_MIRRORS"]          = "Elixir de espejos"                 -- http://es.wowhead.com/spell=105687    
L["G_MANTID_ELIXIR"]              = "Elixir mántide"                    -- http://es.wowhead.com/spell=105681    
-- CATACLYSM
L["G_ELIXIR_OF_DEEP_EARTH"]       = "Elixir del interior de la tierra"  -- http://es.wowhead.com/spell=79480
L["G_PRISMATIC_ELIXIR"]           = "Elixir centelleante"               -- http://es.wowhead.com/spell=79631
-- PRE-CATA
L["G_ARMOR"]                      = "Armadura"                          -- http://www.wowhead.com/?spell=3220
L["G_CRYSTAL_FORCE"]              = "Fuerza de cristal"                 -- http://www.wowhead.com/?spell=15231
L["G_CRYSTAL_WARD"]               = "Resguardo de cristal"              -- http://www.wowhead.com/?spell=15233
L["G_EARTHEN_ELIXIR"]             = "Elixir terráneo"                   -- http://www.wowhead.com/?spell=39626
L["G_ELIXIR_OF_DRAENIC_WISDOM"]   = "Elixir de sabiduría draénica"      -- http://www.wowhead.com/?spell=39627
L["G_ELIXIR_OF_FORTITUDE"]        = "Elixir de entereza"                -- http://www.wowhead.com/?spell=3593
L["G_ELIXIR_OF_IRONSKIN"]         = "Elixir de piel de hierro"          -- http://www.wowhead.com/?spell=39628
L["G_ELIXIR_OF_MAJOR_FORTITUDE"]  = "Elixir de entereza sublime"        -- http://www.wowhead.com/?spell=39625
L["G_ELIXIR_OF_MIGHTY_FORTITUDE"] = "Elixir de entereza poderosa"       -- http://www.wowhead.com/?spell=53751
L["G_ELIXIR_OF_SPIRIT"]           = "Elixir de espíritu"                -- http://www.wowhead.com/?spell=53747
L["G_ELIXIR_OF_THE_SAGES"]        = "Elixir de los sabios"              -- http://www.wowhead.com/?spell=17535
L["G_EMPOWERMENT"]                = "Potenciación"                      -- http://www.wowhead.com/?spell=28514
L["G_GIFT_OF_ARTHAS"]             = "Ofrenda de Arthas"                 -- http://www.wowhead.com/?spell=11371
L["G_GREATER_ARMOR"]              = "Armadura superior"                 -- http://www.wowhead.com/?spell=11348
L["G_GREATER_INTELLECT"]          = "Intelecto superior"                -- http://www.wowhead.com/?spell=11396
L["G_GREATER_MANA_REGENERATION"]  = "Regeneración de maná superior"     -- http://www.wowhead.com/?spell=28509
L["G_HEALTH"]                     = "Salud"                             -- http://www.wowhead.com/?spell=2378
L["G_INFALLIBLE_MIND"]            = "Mente infalible"                   -- http://www.wowhead.com/?spell=10692
L["G_JUJU_CHILL"]                 = "Escalofrío Juju"                   -- http://www.wowhead.com/?spell=16325
L["G_JUJU_EMBER"]                 = "Ascua Juju"                        -- http://www.wowhead.com/?spell=16326
L["G_JUJU_ESCAPE"]                = "Escape Juju"                       -- http://www.wowhead.com/?spell=16321
L["G_JUJU_GUILE"]                 = "Astucia Juju"                      -- http://www.wowhead.com/?spell=16327
L["G_LESSER_ARMOR"]               = "Armadura inferior"                 -- http://www.wowhead.com/?spell=673 
L["G_LESSER_INTELLECT"]           = "Intelecto inferior"                -- http://www.wowhead.com/?spell=3166
L["G_MAGEBLOOD_ELIXIR"]           = "Elixir de sangre de mago"          -- http://www.wowhead.com/?spell=24363
L["G_MAJOR_ARMOR"]                = "Armadura sublime"                  -- http://www.wowhead.com/?spell=28502
L["G_MAJOR_TROLLS_BLOOD_ELIXIR"]  = "Elixir de sangre de trol poderoso" -- http://www.wowhead.com/?spell=24361
L["G_MIGHTY_DEFENSE"]             = "Defensa poderosa"                  -- http://www.wowhead.com/?spell=60343
L["G_MIGHTY_MANA_REGENERATION"]   = "Regeneración de maná poderosa"     -- http://www.wowhead.com/?spell=53764
L["G_MIGHTY_THOUGHTS"]            = "Pensamientos poderosos"            -- http://www.wowhead.com/?spell=60347
L["G_MIGHTY_TROLLS_BLOOD_ELIXIR"] = "Elixir de sangre de trol sublime"  -- http://www.wowhead.com/?spell=3223
L["G_PROTECTION"]                 = "Protección"                        -- http://www.wowhead.com/?spell=53763
L["G_SHEEN_OF_ZANZA"]             = "Brillo de Zanza"                   -- http://www.wowhead.com/?spell=24417
L["G_SPIRIT_OF_BOAR"]             = "Espíritu de jabalí"                -- http://www.wowhead.com/?spell=10668
L["G_SPIRIT_OF_ZANZA"]            = "Espíritu de Zanza"                 -- http://www.wowhead.com/?spell=24382
L["G_SPIRITUAL_DOMINATION"]       = "Dominación espiritual"             -- http://www.wowhead.com/?spell=10693
L["G_STRONG_TROLLS_BLOOD_ELIXIR"] = "Elixir de sangre de trol fuerte"   -- http://www.wowhead.com/?spell=3222
L["G_SWIFTNESS_OF_ZANZA"]         = "Presteza de Zanza"                 -- http://www.wowhead.com/?spell=24383
L["G_WATER_WALKING"]              = "Caminar sobre el agua"             -- http://www.wowhead.com/?spell=11319
L["G_WEAK_TROLLS_BLOOD_ELIXIR"]   = "Elixir de sangre de trol débil"    -- http://www.wowhead.com/?spell=3219

-- Battle Elixirs. The description fields are for the BUFFS given by these elixirs, NOT from the actual elixir item.
-- WARLORDS of DRAENOR
-- MISTS OF PANDARIA
L["B_MAD_HOZEN_ELIXIR"]             = "Elixir de hozen loco"      -- http://es.wowhead.com/spell=114754
L["B_ELIXIR_OF_THE_RAPIDS"]         = "Elixir de los rápidos"     -- http://es.wowhead.com/spell=105684
L["B_ELIXIR_OF_PERFECTION"]         = "Elixir de perfección"      -- http://es.wowhead.com/spell=105686
L["B_ELIXIR_OF_PEACE"]              = "Elixir de paz"             -- http://es.wowhead.com/spell=105685
L["B_ELIXIR_OF_WEAPONRY"]           = "Elixir de armamento"       -- http://es.wowhead.com/spell=105683
L["B_MONKS_ELIXIR"]                 = "Elixir de monje"           -- http://es.wowhead.com/spell=105688
-- CATACLYSM
L["B_ELIXIR_OF_IMPOSSIBLE_ACCURACY"] = "Precisión imposible"      -- http://es.wowhead.com/spell=79481
L["B_ELIXIR_OF_MIGHTY_SPEED"]        = "Velocidad poderosa"       -- http://es.wowhead.com/spell=79632
L["B_ELIXIR_OF_THE_COBRA"]           = "Elixir de la cobra"       -- http://es.wowhead.com/spell=79477
L["B_ELIXIR_OF_THE_MASTER"]          = "Elixir del maestro"       -- http://es.wowhead.com/spell=79635
L["B_ELIXIR_OF_THE_NAGA"]            = "Elixir de los nagas"      -- http://es.wowhead.com/spell=79474
L["B_GHOST_ELIXIR"]                  = "Elixir de fantasma"       -- http://es.wowhead.com/spell=79468
-- PRE-CATA
L["B_ACCURACY"]                 = "Precisión"                     --http://es.wowhead.com/?spell=60340
L["B_ADEPTS_ELIXIR"]            = "Elixir de adepto"              --http://es.wowhead.com/?spell=54452
L["B_AGILITY"]                  = "Agilidad"                      --http://es.wowhead.com/?spell=11328
L["B_ARCANE_ELIXIR"]            = "Elixir Arcano"                 --http://es.wowhead.com/?spell=11390
L["B_ARMOR_PIERCING"]           = "Perforar armadura"             --http://es.wowhead.com/?spell=60345
L["B_BLOODBERRY"]               = "Baya de sangre"                --http://es.wowhead.com/?spell=45373
L["B_DEADLY_STRIKES"]           = "Golpes letales"                --http://es.wowhead.com/?spell=60341
L["B_ELIXIR_OF_BRUTE_FORCE"]    = "Elixir de fuerza bruta"        --http://es.wowhead.com/?spell=17537
L["B_ELIXIR_OF_DEMONSLAYING"]   = "Elixir de matanza de demonios" --http://es.wowhead.com/?spell=11406
L["B_ELIXIR_OF_MASTERY"]        = "Elixir de maestría"            --http://es.wowhead.com/?spell=33726
L["B_ELIXIR_OF_MINOR_ACCURACY"] = "Elixir de Precisión menor"     --http://es.wowhead.com/?spell=63729
L["B_ELIXIR_OF_THE_GIANTS"]     = "Elixir de los gigantes"        --http://es.wowhead.com/?spell=11405
L["B_ELIXIR_OF_THE_MONGOOSE"]   = "Elixir de la mangosta"         --http://es.wowhead.com/?spell=17538
L["B_ENLARGE"]                  = "Agrandar"                      --http://es.wowhead.com/?spell=8212
L["B_EXPERTISE"]                = "Pericia"                       --http://es.wowhead.com/?spell=60344
L["B_FEL_STRENGTH_ELIXIR"]      = "Elixir de fuerza vil"          --http://es.wowhead.com/?spell=38954
L["B_FIRE_POWER"]               = "Poder de Fuego"                --http://es.wowhead.com/?spell=7844
L["B_FROST_POWER"]              = "Poder de Escarcha"             --http://es.wowhead.com/?spell=21920
L["B_GREATER_AGILITY"]          = "Agilidad superior"             --http://es.wowhead.com/?spell=11334
L["B_GREATER_ARCANE_ELIXIR"]    = "Elixir Arcano superior"        --http://es.wowhead.com/?spell=16889
L["B_GREATER_FIREPOWER"]        = "Poder de Fuego superior"       --http://es.wowhead.com/?spell=26276
L["B_GURUS_ELIXIR"]             = "Elixir de gurú"                --http://es.wowhead.com/?spell=53749
L["B_HEALING_POWER"]            = "Poder de sanación"             --http://es.wowhead.com/?spell=28491
L["B_JUJU_FLURRY"]              = "Aluvión Juju"                  --http://es.wowhead.com/?spell=16322
L["B_JUJU_MIGHT"]               = "Poderío Juju"                  --http://es.wowhead.com/?spell=16329
L["B_JUJU_POWER"]               = "Poder Juju"                    --http://es.wowhead.com/?spell=16323
L["B_LESSER_AGILITY"]           = "Agilidad inferior"             --http://es.wowhead.com/?spell=2374
L["B_LESSER_STRENGTH"]          = "Fuerza inferior"               --http://es.wowhead.com/?spell=2367
L["B_LIGHTNING_SPEED"]          = "Velocidad de relámpago"        --http://es.wowhead.com/?spell=60346
L["B_MAJOR_AGILITY"]            = "Agilidad sublime"              --http://es.wowhead.com/?spell=54494
L["B_MAJOR_FIREPOWER"]          = "Poder de Fuego sublime"        --http://es.wowhead.com/?spell=28501
L["B_MAJOR_FROST_POWER"]        = "Poder de Escarcha sublime"     --http://es.wowhead.com/?spell=28493
L["B_MAJOR_SHADOW_POWER"]       = "Poder de las Sombras sublime"  --http://es.wowhead.com/?spell=28503
L["B_MAJOR_STRENGTH"]           = "Fuerza sublime"                --http://es.wowhead.com/?spell=28490
L["B_MIGHTY_AGILITY"]           = "Agilidad poderosa"             --http://es.wowhead.com/?spell=28497
L["B_MIGHTY_STRENGTH"]          = "Fuerza poderosa"               --http://es.wowhead.com/?spell=53748
L["B_ONSLAUGHT_ELIXIR"]         = "Elixir de acometida"           --http://es.wowhead.com/?spell=33720
L["B_RAGE_OF_AGES"]             = "Ira de los tiempos"            --http://es.wowhead.com/?spell=10667
L["B_SHADOW_POWER"]             = "Poder de las Sombras"          --http://es.wowhead.com/?spell=11474
L["B_SPELLPOWER_ELIXIR"]        = "Elixir de poder con hechizos"  --http://es.wowhead.com/?spell=33721
L["B_STRENGTH"]                 = "Fuerza"                        --http://es.wowhead.com/?spell=3164
L["B_STRIKE_OF_THE_SCORPOK"]    = "Golpe de Scorpok"              --http://es.wowhead.com/?spell=10669
L["B_WINTERFALL_FIREWATER"]     = "Aguardiente Nevada"            --http://es.wowhead.com/?spell=17038
L["B_WRATH_ELIXIR"]             = "Elixir de cólera"              --http://es.wowhead.com/?spell=53746

-- Name of the Well Fed BUFF (not the food), and all food buffs = "Well Fed" in English. 
L["WELL_FED"] = "Bien alimentado";

